#include "OrderEntry.h"

#define WIN32_LEAN_AND_MEAN
#define MT4_EXPFUNC __declspec(dllexport)
//+-----------------------------------------------------------------------------------------------------------------------------+
//|															MT4 DATA STRUCT							                            |
//+-----------------------------------------------------------------------------------------------------------------------------+
#pragma pack(push,1)
struct RateInfo { unsigned int ctm; double open; double low; double high; double close; double vol; };
struct MqlStr   {          int len; char   * string;												};
#pragma pack(pop)
//+-----------------------------------------------------------------------------------------------------------------------------+

using namespace System;
using namespace System::Threading;

ref class Global {
public:
	static MetaScalper::OrderEntry^ oe = (gcnew MetaScalper::OrderEntry());
	static MetaScalper::UIThread^ uitr = (gcnew MetaScalper::UIThread());
};

MT4_EXPFUNC void _stdcall WakeUp(char* symbol) {
	String^ s = gcnew String(symbol);
	Global::oe->Text = String::Concat(" MetaScalper - ", s);
	Global::uitr->myForm = Global::oe;
	Thread^ t = gcnew Thread(gcnew ThreadStart(Global::uitr, &MetaScalper::UIThread::startUI));
	t->Start();
}

MT4_EXPFUNC double _stdcall GetAbsoluteTarget3() {
	if (Global::oe->textBoxT3->Text != "") {
		return (double) Double::Parse(Global::oe->textBoxT3->Text);
	}
	else {
		return 0;
	}
}

MT4_EXPFUNC double _stdcall GetAbsoluteTarget2() {
	if (Global::oe->textBoxT2->Text != "") {
		return (double) Double::Parse(Global::oe->textBoxT2->Text);
	}
	else {
		return 0;
	}
}

MT4_EXPFUNC double _stdcall GetAbsoluteTarget1() {
	if (Global::oe->textBoxT1->Text != "") {
		return (double) Double::Parse(Global::oe->textBoxT1->Text);
	}
	else {
		return 0;
	}
}

MT4_EXPFUNC double _stdcall GetAbsoluteStop() {
	if (Global::oe->textBoxStop->Text != "") {
		return (double) Double::Parse(Global::oe->textBoxStop->Text);
	}
	else {
		return 0;
	}
}

MT4_EXPFUNC int _stdcall GetTarget3() {
	return (int) Int32::Parse(Global::oe->numericUpDownTarget3->Text);
}

MT4_EXPFUNC int _stdcall GetTarget2() {
	return (int) Int32::Parse(Global::oe->numericUpDownTarget2->Text);
}

MT4_EXPFUNC int _stdcall GetTarget1() {
	return (int) Int32::Parse(Global::oe->numericUpDownTarget1->Text);
}

MT4_EXPFUNC int _stdcall GetStop() {
	return (int) Int32::Parse(Global::oe->numericUpDownStop->Text);
}

MT4_EXPFUNC int _stdcall GetAdjustLots() {
	return (int) Int32::Parse(Global::oe->numericUpDownLotsAdjust->Text);
}

MT4_EXPFUNC int _stdcall GetOpenLots() {
	return (int) Int32::Parse(Global::oe->numericUpDownLots->Text);
}

MT4_EXPFUNC bool _stdcall IsStopActive() {
	return Global::oe->checkBoxStop->Checked;
}

MT4_EXPFUNC bool _stdcall IsTarget1Active() {
	return Global::oe->checkBoxTarget1->Checked;
}

MT4_EXPFUNC bool _stdcall IsTarget2Active() {
	return Global::oe->checkBoxTarget2->Checked;
}

MT4_EXPFUNC bool _stdcall IsTarget3Active() {
	return Global::oe->checkBoxTarget3->Checked;
}

MT4_EXPFUNC double _stdcall GetLotSize() {
	return (double) Double::Parse(Global::oe->comboBoxLotSize->Text);
}

MT4_EXPFUNC int _stdcall GetEvent() {
	int ret = Global::oe->event;
	Global::oe->event = 0;
	return ret;
}

MT4_EXPFUNC int _stdcall Test() {
	return 99;
}
